/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PREFIXOCIA                                               */
/* Tabela : PREFIXOCIA                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 13/10/2003 Bruno Leonardo                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PREFIXOCIA
BEFORE INSERT OR UPDATE OR DELETE
ON PREFIXOCIA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPREC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL    ,0) <> NVL(:NEW.CDFILIAL    ,0)) OR
         (NVL(:OLD.CDCIA       ,0) <> NVL(:NEW.CDCIA       ,0)) OR
         (NVL(:OLD.SGPREFIXO   ,0) <> NVL(:NEW.SGPREFIXO   ,0)) OR
         (NVL(:OLD.CDEQUIP     ,0) <> NVL(:NEW.CDEQUIP     ,0)) OR
         (NVL(:OLD.SGPREFIXO   ,0) <> NVL(:NEW.SGPREFIXO   ,0)) OR
         (NVL(:OLD.QTTOTPAXPREF,0) <> NVL(:NEW.QTTOTPAXPREF,0)) THEN
         :NEW.DTULTATUPREC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PREFIXOCIA', '', 'CDFILIAL='||:OLD.CDFILIAL||';CDCIA='||:OLD.CDCIA||';SGPREFIXO='||:OLD.SGPREFIXO||';',SYSDATE);
   END IF;
END;
/

ALTER TABLE PREFIXOCIA MODIFY DTULTATUPREC DEFAULT SYSDATE
/
