/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODCOMP                                                 */
/* Tabela : PRODCOMP                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 03/07/2000 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PRODCOMP
BEFORE INSERT OR UPDATE OR DELETE
ON PRODCOMP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPRCMP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPRODUTO,0)  <> NVL(:NEW.CDPRODUTO,0)) OR
         (NVL(:OLD.CDOPERADOR,0) <> NVL(:NEW.CDOPERADOR,0)) THEN
         :NEW.DTULTATUPRCMP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRODCOMP', '', 'CDOPERADOR='||:OLD.CDOPERADOR||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRODCOMP MODIFY DTULTATUPRCMP DEFAULT SYSDATE
/
