var LocalStorageEngine = function(ZhLogger, requestDataSourceEngine, requestFactory, requestEngine, templateManager, DataSourceHolder, ZHPromise,
	ZhUtil, Query) {
	Util.extend(this, new StorageEngine(ZhUtil));

	var self = this;

	this._prepareData = function(storagedData) {
		var data = JSON.parse(storagedData);
		if (Util.isArray(data)) {
			data = data.filter(function(item){
				return !!item;
			})
			.map(function(item) {
				item.__is_new = !!item.__is_new;
				return item;
			});
		}
		return data;
	};

	this.getDataSourceItems = function(name){
		return localforage.getItem(name);
	};

	self._removeAll = function(name) {
		return localforage.removeItem(name);
	};

	this._setItem = function(name, data){
		return localforage.setItem(name, JSON.stringify(data));
	};

	this.getLocalVar = function(name) {
		var data = localStorage.getItem(name);
		if (data && data !== 'undefined') {
			return (JSON.parse(data));
		} else {
			return;
		}
	};
	var _clearArrayVar = function(localVar) {
		var result = localVar;
		if (Util.isObject(localVar)) {
			result = ZhUtil.clearRow(localVar);
		}
		return result;
	};
	this.setLocalVar = function(name, localVar) {
		var cleaned;
		if (Array.isArray(localVar)) {
			cleaned = localVar.map(_clearArrayVar);
		} else if (Util.isObject(localVar)) {
			cleaned = ZhUtil.clearRow(localVar);
		} else {
			cleaned = localVar;
		}
		localStorage.setItem(name, JSON.stringify(cleaned));
	};

	Util.decorateFromConstructor(self, Storageable, arguments);
	var _setDefaultValues = (function(widget) {
		Util.extend(widget, new Filterable(ZhUtil, Query));
	})(this);
};